;--------------------------------------------------
;
; Data
;
DATA		SEGMENT WORD PUBLIC
		ASSUME	DS:DATA

EXTRN    Plane1     : Dword;
EXTRN    Ty1        : word;
EXTRN    Tx1        : word;
EXTRN    TDy        : Dword;
EXTRN    TDx        : Dword;
EXTRN    Tx2        : Dword;
EXTRN    TScaleX    : Dword;
EXTRN    TShape     : Dword;
EXTRN    Tscy       : Dword;


EXTRN    WXB        : Dword;
EXTRN    WYB        : Dword;
EXTRN    WX         : word;
EXTRN    WY         : word;

DATA		ENDS


;--------------------------------------------------
;
; Code
;
          .286

CODE 	SEGMENT PUBLIC
		ASSUME	CS:CODE

ScreenWidth              equ  352/4

SEQ_ADDR		          equ	03C4h
SEQ_DATA	    	          equ	03C5h
SEQ_MEMORY_MODE		equ	4
SEQ_04h_C4		     equ	8
SEQ_04h_OE		     equ	4
SEQ_04h_EM		     equ	2


GRAPHC_ADDR		     equ	03CEh
GRAPHC_DATA		     equ	03CFh
GRAPHC_SR		          equ	0
GRAPHC_ENABLE_SR	     equ	1
GRAPHC_DATA_ROTATE	     equ	3
GRAPHC_MODE		     equ	5
GRAPHC_BIT_MASK	     equ	8

SHIFT_REG_2		     equ	040h
READ_MODE_0		     equ	0
READ_MODE_1		     equ	8
WRITE_MODE_0		     equ	0
WRITE_MODE_1		     equ	01
WRITE_MODE_2		     equ	02
WRITE_MODE_3		     equ	03

VIDSEG				equ	0A000h
VRAM                     equ	0A000h
VRAM_LIMIT               equ	01000h


SSTAKEL	macro
	push	bp					; // Fix stack for local variables
	mov	bp,sp
	sub	sp,AUTO_SIZE
           endm

SSTACK  	macro
	push	bp					; // Fix stack for local variables
	mov	bp,sp
	endm

RSTACK	macro
	mov	sp,bp					; // restore stack for exit
	pop	bp
	endm


            .386P
;******************************************************************************
;
;
;    Draw scaled line (backwards for right side clipping)
;
;******************************************************************************

BDoLine   macro  size,NoPixels,t2
         local  count,base,temp,cnt
BTmpX_&t2:
         cnt=NoPixels-1
         count=(size*65536)/NoPixels		; Get index fraction.
         base=count*(NoPixels-1)		; Get LAST pixel offset.
         rept  NoPixels
             temp=base/65536
             DB     08Ah,09Ch                    ; mov   bl,ds:[si+temp]
             DB     LOW  (Temp)
             DB     HIGH (Temp)
             DB     026H,088h,09Dh		; mov   es:[di+cnt],bl
             DB     LOW  (cnt)
             DB     HIGH (cnt)
             base=(base-count)
             cnt=(cnt-1)
         endm
         ret
         endm

;******************************************************************************
;
; Actual code bits, lines then tables
;
;******************************************************************************
BScaleLines proc
           public   BScaleLines

             BDoLine  64,1,%1                     ; Loop round make code
             BDoLine  64,2,%2                     ; Loop round make code
             BDoLine  64,3,%3                     ; Loop round make code
             BDoLine  64,4,%4                     ; Loop round make code
             BDoLine  64,5,%5                     ; Loop round make code
             BDoLine  64,6,%6                     ; Loop round make code
             BDoLine  64,7,%7                     ; Loop round make code
             BDoLine  64,8,%8                     ; Loop round make code
             BDoLine  64,9,%9                     ; Loop round make code
             BDoLine  64,10,%10                     ; Loop round make code

             BDoLine  64,11,%11                     ; Loop round make code
             BDoLine  64,12,%12                     ; Loop round make code
             BDoLine  64,13,%13                     ; Loop round make code
             BDoLine  64,14,%14                     ; Loop round make code
             BDoLine  64,15,%15                     ; Loop round make code
             BDoLine  64,16,%16                     ; Loop round make code
             BDoLine  64,17,%17                     ; Loop round make code
             BDoLine  64,18,%18                     ; Loop round make code
             BDoLine  64,19,%19                     ; Loop round make code
             BDoLine  64,20,%20                     ; Loop round make code

             BDoLine  64,21,%21                     ; Loop round make code
             BDoLine  64,22,%22                     ; Loop round make code
             BDoLine  64,23,%23                     ; Loop round make code
             BDoLine  64,24,%24                     ; Loop round make code
             BDoLine  64,25,%25                     ; Loop round make code
             BDoLine  64,26,%26                     ; Loop round make code
             BDoLine  64,27,%27                     ; Loop round make code
             BDoLine  64,28,%28                     ; Loop round make code
             BDoLine  64,29,%29                     ; Loop round make code
             BDoLine  64,30,%30                     ; Loop round make code

             BDoLine  64,31,%31                     ; Loop round make code
             BDoLine  64,32,%32                     ; Loop round make code
             BDoLine  64,33,%33                     ; Loop round make code
             BDoLine  64,34,%34                     ; Loop round make code
             BDoLine  64,35,%35                     ; Loop round make code
             BDoLine  64,36,%36                     ; Loop round make code
             BDoLine  64,37,%37                     ; Loop round make code
             BDoLine  64,38,%38                     ; Loop round make code
             BDoLine  64,39,%39                     ; Loop round make code
             BDoLine  64,40,%40                     ; Loop round make code

             BDoLine  64,41,%41                     ; Loop round make code
             BDoLine  64,42,%42                     ; Loop round make code
             BDoLine  64,43,%43                     ; Loop round make code
             BDoLine  64,44,%44                     ; Loop round make code
             BDoLine  64,45,%45                     ; Loop round make code
             BDoLine  64,46,%46                     ; Loop round make code
             BDoLine  64,47,%47                     ; Loop round make code
             BDoLine  64,48,%48                     ; Loop round make code
             BDoLine  64,49,%49                     ; Loop round make code
             BDoLine  64,50,%50                     ; Loop round make code

             BDoLine  64,51,%51                     ; Loop round make code
             BDoLine  64,52,%52                     ; Loop round make code
             BDoLine  64,53,%53                     ; Loop round make code
             BDoLine  64,54,%54                     ; Loop round make code
             BDoLine  64,55,%55                     ; Loop round make code
             BDoLine  64,56,%56                     ; Loop round make code
             BDoLine  64,57,%57                     ; Loop round make code
             BDoLine  64,58,%58                     ; Loop round make code
             BDoLine  64,59,%59                     ; Loop round make code
             BDoLine  64,60,%60                     ; Loop round make code

             BDoLine  64,61,%61                     ; Loop round make code
             BDoLine  64,62,%62                     ; Loop round make code
             BDoLine  64,63,%63                     ; Loop round make code
             BDoLine  64,64,%64                     ; Loop round make code
             BDoLine  64,65,%65                     ; Loop round make code
             BDoLine  64,66,%66                     ; Loop round make code
             BDoLine  64,67,%67                     ; Loop round make code
             BDoLine  64,68,%68                     ; Loop round make code
             BDoLine  64,69,%69                     ; Loop round make code
             BDoLine  64,70,%70                     ; Loop round make code

             BDoLine  64,71,%71                     ; Loop round make code
             BDoLine  64,72,%72                     ; Loop round make code
             BDoLine  64,73,%73                     ; Loop round make code
             BDoLine  64,74,%74                     ; Loop round make code
             BDoLine  64,75,%75                     ; Loop round make code
             BDoLine  64,76,%76                     ; Loop round make code
             BDoLine  64,77,%77                     ; Loop round make code
             BDoLine  64,78,%78                     ; Loop round make code
             BDoLine  64,79,%79                     ; Loop round make code
             BDoLine  64,80,%80                     ; Loop round make code

             BDoLine  64,81,%81                     ; Loop round make code
             BDoLine  64,82,%82                     ; Loop round make code
             BDoLine  64,83,%83                     ; Loop round make code
             BDoLine  64,84,%84                     ; Loop round make code
             BDoLine  64,85,%85                     ; Loop round make code
             BDoLine  64,86,%86                     ; Loop round make code
             BDoLine  64,87,%87                     ; Loop round make code
             BDoLine  64,88,%88                     ; Loop round make code
             BDoLine  64,89,%89                     ; Loop round make code
             BDoLine  64,90,%90                     ; Loop round make code

             BDoLine  64,91,%91                     ; Loop round make code
             BDoLine  64,92,%92                     ; Loop round make code
             BDoLine  64,93,%93                     ; Loop round make code
             BDoLine  64,94,%94                     ; Loop round make code
             BDoLine  64,95,%95                     ; Loop round make code
             BDoLine  64,96,%96                     ; Loop round make code
             BDoLine  64,97,%97                     ; Loop round make code
             BDoLine  64,98,%98                     ; Loop round make code
             BDoLine  64,99,%99                     ; Loop round make code
             BDoLine  64,100,%100                     ; Loop round make code
;
;             BDoLine  64,101,%101                     ; Loop round make code
;             BDoLine  64,102,%102                     ; Loop round make code
;             BDoLine  64,103,%103                     ; Loop round make code
;             BDoLine  64,104,%104                     ; Loop round make code
;             BDoLine  64,105,%105                     ; Loop round make code
;             BDoLine  64,106,%106                     ; Loop round make code
;             BDoLine  64,107,%107                     ; Loop round make code
;             BDoLine  64,108,%108                     ; Loop round make code
;             BDoLine  64,109,%109                     ; Loop round make code
;             BDoLine  64,110,%110                     ; Loop round make code


BScaleLines Endp


BScaleLineTable proc
           public  BScaleLineTable
           dd      BTmpX_1
           dd      BTmpX_2
           dd      BTmpX_3
           dd      BTmpX_4
           dd      BTmpX_5
           dd      BTmpX_6
           dd      BTmpX_7
           dd      BTmpX_8
           dd      BTmpX_9
           dd      BTmpX_10

           dd      BTmpX_11
           dd      BTmpX_12
           dd      BTmpX_13
           dd      BTmpX_14
           dd      BTmpX_15
           dd      BTmpX_16
           dd      BTmpX_17
           dd      BTmpX_18
           dd      BTmpX_19
           dd      BTmpX_20

           dd      BTmpX_21
           dd      BTmpX_22
           dd      BTmpX_23
           dd      BTmpX_24
           dd      BTmpX_25
           dd      BTmpX_26
           dd      BTmpX_27
           dd      BTmpX_28
           dd      BTmpX_29
           dd      BTmpX_30

           dd      BTmpX_31
           dd      BTmpX_32
           dd      BTmpX_33
           dd      BTmpX_34
           dd      BTmpX_35
           dd      BTmpX_36
           dd      BTmpX_37
           dd      BTmpX_38
           dd      BTmpX_39
           dd      BTmpX_40

           dd      BTmpX_41
           dd      BTmpX_42
           dd      BTmpX_43
           dd      BTmpX_44
           dd      BTmpX_45
           dd      BTmpX_46
           dd      BTmpX_47
           dd      BTmpX_48
           dd      BTmpX_49
           dd      BTmpX_50

           dd      BTmpX_51
           dd      BTmpX_52
           dd      BTmpX_53
           dd      BTmpX_54
           dd      BTmpX_55
           dd      BTmpX_56
           dd      BTmpX_57
           dd      BTmpX_58
           dd      BTmpX_59
           dd      BTmpX_60

           dd      BTmpX_61
           dd      BTmpX_62
           dd      BTmpX_63
           dd      BTmpX_64
           dd      BTmpX_65
           dd      BTmpX_66
           dd      BTmpX_67
           dd      BTmpX_68
           dd      BTmpX_69
           dd      BTmpX_70

           dd      BTmpX_71
           dd      BTmpX_72
           dd      BTmpX_73
           dd      BTmpX_74
           dd      BTmpX_75
           dd      BTmpX_76
           dd      BTmpX_77
           dd      BTmpX_78
           dd      BTmpX_79
           dd      BTmpX_80

           dd      BTmpX_81
           dd      BTmpX_82
           dd      BTmpX_83
           dd      BTmpX_84
           dd      BTmpX_85
           dd      BTmpX_86
           dd      BTmpX_87
           dd      BTmpX_88
           dd      BTmpX_89
           dd      BTmpX_90

           dd      BTmpX_91
           dd      BTmpX_92
           dd      BTmpX_93
           dd      BTmpX_94
           dd      BTmpX_95
           dd      BTmpX_96
           dd      BTmpX_97
           dd      BTmpX_98
           dd      BTmpX_99
           dd      BTmpX_100


           dd      BTmpX_100
           dd      BTmpX_100
           dd      BTmpX_100
           dd      BTmpX_100
           dd      BTmpX_100
           dd      BTmpX_100
           dd      BTmpX_100
           dd      BTmpX_100
           dd      BTmpX_100
           dd      BTmpX_100
           dd      BTmpX_100
           dd      BTmpX_100
           dd      BTmpX_100
           dd      BTmpX_100
           dd      BTmpX_100
           dd      BTmpX_100
           dd      BTmpX_100
           dd      BTmpX_100
           dd      BTmpX_100
           dd      BTmpX_100
           dd      BTmpX_100
           dd      BTmpX_100
           dd      BTmpX_100
           dd      BTmpX_100
           dd      BTmpX_100
           dd      BTmpX_100
           dd      BTmpX_100
           dd      BTmpX_100
           dd      BTmpX_100
           dd      BTmpX_100
           dd      BTmpX_100

;

;           dd      BTmpX_101
;           dd      BTmpX_102
;           dd      BTmpX_103
;           dd      BTmpX_104
;           dd      BTmpX_105
;           dd      BTmpX_106
;           dd      BTmpX_107
;           dd      BTmpX_108
;           dd      BTmpX_109
;           dd      BTmpX_110


BScaleLineTable endp

;******************************************************************************
;
;    Draw a scaled Block. Clip line if>=320
;
;******************************************************************************
DrawaScaledBlockC  proc far
                  public   DSBClippedLeft
          EVENDATA
cnt       =    320
_Table:   dw   0
          rept      200
          dw  cnt
cnt       = cnt+320
          endm
;---------

          EVENDATA
cnt       =    0
SkipTable:
          rept      63
          dw  cnt
cnt       = cnt+9
          endm
          rept 200
          dw   64*9
          endm
_Xclip    dw   0
_Xsize    dw   0

ty           dd    0
_Dx          dd    0
_Dy          dd    0
_tScy        dd    0
_ScaleX      dd    0
_x2          dd    0
_tt          dd    0

_WXB      dd   0	
_WYB      dd   0	
_WX       dw   0

DSBClippedLeft:
          SSTack
 		push	di
          push	es
          push	ds


          mov  eax,wxb
          mov  _WXB,eax
          mov  eax,wyb
          mov  _WYB,eax
          mov  ax,WX
          dec  ax
          mov  _WX,ax
          mov  eax,TscaleX    ; Copy Paramaters over
          mov  _ScaleX,eax
          mov  eax,Tscy       ; Copy Paramaters over
          mov  _tScy,eax
          mov  eax,Tdx        ; Copy Paramaters over
          mov  _Dx,eax
          mov  eax,Tdy
          mov  _Dy,eax
          mov  eax,Tx2
          mov  _x2,eax

          mov  cx,Tx1         ; scale x cord up!
          shl  ecx,16
          mov  ax,Ty1         ; scale Y cord up!
          shl  eax,16
          mov  edx,08000h

          les  di,Plane1
		lds	si,TShape		 ; get graphic address

@SLoop2:
          push si
          push di

          mov  ebx,eax         ; work out NEW X,Y pos on screen.
          shr  ebx,16
          add  bx,bx
          add  di,word ptr _Table[bx]    ;[ebx*2] is better
          shld ebx,ecx,16      ; Get X cord and add on.
          add  di,bx

          cmp  eax,_WYB        ; 200*010000h
          jae  @SkipX2

          mov  ebx,edx          ; work out new start in texture
          shr  ebx,10           ; (new start LINE)
          and  bx,0ffc0h
          add  si,bx


          mov  _Xclip,0
          mov  _Xsize,0
          mov  ebx,_x2          ; Work out address for line printing Jump table
          cmp  ebx,_WXB         ; 320*65536    ; ie get the CLIP size
          jl  @ok
          shr  ebx,16
          sub  bx,_WX           ;319        ; Sub off Screen width - get how much is OVER
          mov  _Xsize,bx
          add  bx,bx            ; Get CLIP size
          mov  bx,word ptr SkipTable[bx]
          mov  _Xclip,bx

@ok:      mov  ebx,_x2
          sub  ebx,ecx         ; Get WIDTH to print!
          shr  ebx,16          ; shr 16, *4
          cmp  bx,_Xsize
          jl   @SkipX2

          add  bx,bx
          add  bx,bx
          add  bx,offset BScaleLineTable
          mov  bx,cs:[bx]
          add  bx,_Xclip
          call bx

@SkipX2:
          mov  ebx,_ScaleX    ; Line Draw on X (right side)
          add  _X2,ebx
          add  eax,_Dy
          add  ecx,_Dx        ; Line draw on X,Y (left side)
          add  edx,_tScy       ; Scale Texture on Y axis

          pop  di
          pop  si
          cmp  edx,0400000h
          jle  @SLoop2


@TExit2:	pop	ds
          pop	es
          pop	di

          RSTACK
          ret

DrawaScaledBlockC   endp

CODE	ENDS
     END

